<template>
  <dashboard-layout :link="1">
    <div v-if="isLoading" class="py-5 text-center">
      <vue-loaders class="py-5" name="ball-beat" color="#fa8357" scale="2"></vue-loaders>
    </div>
    <div v-else class="mb-4">
      <div v-if="curStep==0" class="m-2">
        <h3 class="text-dark my-2">Liste des Articles</h3>
        <!-- <h3 v-else class="text-dark my-2">Liste des {{userType +'s'}}</h3> -->
        <div class="card mt-4 col-sm-12">
          <div class="row my-4 mx-2">
            <div class="fa-pull-left col-sm-3 form-group mt-2">
              <label class="mt-2 mr-2 text-dark col-sm-3" for="">Show : </label>
              <select class="ml-2 myform p-1 form-control-min col-sm-3" v-on:change="doPaginate" v-model="paginate">
                <option selected value="5">5</option>
                <option v-if="totalDatabase>5" value="10">10</option>
                <option v-if="totalDatabase>10" value="15">15</option>
                <option v-if="totalDatabase>15" value="20">20</option>
                <option v-if="totalDatabase>20" value="25">25</option>
                <option v-if="totalDatabase>25" value="50">50</option>
              </select>
            </div>
            <div class="col-sm-4 mt-2">
              <div class="input-group md-form form-sm form-2 pl-0">
                <input class="form-control form-control-min my-0 py-1 amber-border" v-model="searchtext"
                  type="search" placeholder="Search by firstname, lastname, email, ..." aria-label="Search">
                <div v-if="searchtext.length>2" class="btn bg-ejima c-pointer input-group-append py-2 px-3"
                  @click="loadData(curNumPage)">
                  <span class="" id="basic-text1">
                    <i class="fa fa-search " aria-hidden="true"></i>
                  </span>
                </div>
                <div v-else class="btn bg-outline-ejima c-pointer input-group-append py-2 px-3">
                  <span class="" id="basic-text1">
                    <i class="fa fa-search " aria-hidden="true"></i>
                  </span>
                </div>
              </div>
            </div>
            <div class="col-sm-2 mt-2">
              <span @click="loadData(0)" class="btn bg-ejima2 fa-pull-right">
                <i class="fa fa-refresh mr-2"></i>
                Refresh
              </span>
            </div>
          </div>
          <div class="card-body table-responsive">
            <table class="table table-striped">
              <thead>
                <tr>
                  <!-- <th>Avatar</th> -->
                  <th>Email</th>
                  <th>Nom du fichier</th>
                  <th>Format</th>
                  <th class="text-center">Apperçu</th>
                  <th>Date d'ajout</th>
                  <th class="text-center">Action</th>
                </tr>              
              </thead>
              <tbody v-if="ressources && ressources.length > 0">
                <tr v-for="(article, i) in ressources" :key="i" class="">
                  
                  <!-- <td>
                    <span class="text-capitalize mr-2">{{article.firstname}} </span>
                    <span class="text-uppercase">{{article.lastname}}</span>
                  </td> -->
                  <td class="text-lowercase">{{ article.email }}</td>
                  <td class="">{{ article.docname }}</td>
                  <td class="text-capitalize">
                    {{article.format}}
                  </td>
                  <td class="text-center">
                    <!-- <span > -->
                      <a v-if="article && article.doc" :href="article.doc" download 
                        class="text-dark h5 c-pointer" title="Télécharger cet article">
                        <i class="fa fa-download"></i>
                      </a>
                    <!-- </span> -->
                    <!-- <embed :src="article.doc" 
                      width=45 height=60 :type="'application/'+article.format"/> -->
                  </td>
                  <td class="text-capitalize">
                    {{getDate(article.createdAt)}}
                  </td>
                  <!-- <td :class="article.statut && article.statut == true ? 'text-primary ' : ' text-secondary2 ' ">
                    {{ article.statut && article.statut == true ? 'Compte Actif' : 'compte Inactif' }}
                  </td> -->
                  <td class="text-center">
                    <span v-if="article && article.etat == 'assign'" class="m-2 p-2 btn-info c-pointer" title="Ouvrir le document" @click="showArticle(article)">
                      <i class="fa fa-eye"></i>
                    </span>
                    <!-- <span></span> -->
                    <span v-else class="p-2 btn-edit" title="Assigner cet article à un reviewer" @click.stop="assignArticle(article)">
                      <i class="fa text-white fa-pencil"></i>
                    </span>
                    
                  </td>
                </tr>
              </tbody>
            </table>
            <div v-if="ressources && ressources.length == 0">
              <h3 class="text-primary2 mt-5 text-center">No match found</h3>
            </div>
          </div>
          <div class="d-flex justify-content-between align-items-center mb-5 mx-3">
            <p>Page {{curNumPage+1}} sur {{numPage}} </p>
            <nav class=''>
              <ul class="pagination justify-content-end">
                <li class="page-item">
                  <span v-if="curNumPage>0" class="page-link c-pointer text-primary2" aria-label="Previous" @click="loadData(curNumPage-1)">
                    <span aria-hidden="true">&laquo;</span>
                    <span class="sr-only">Previous</span>
                  </span>
                  <span v-else class="page-link text-primary2" aria-label="Previous">
                    <span aria-hidden="true">&laquo;</span>
                    <span class="sr-only">Previous</span>
                  </span>
                </li>
                <li class="page-item" v-for="(element, i) in numPage" :key="i">
                  <span v-if="curNumPage==i" :class="(curNumPage==i ? ' active2 text-white ' : ' text-dark') +' page-link c-pointer'" >{{i+1}}</span>
                  <span v-else :class="(curNumPage==i ? ' active2 text-white ' : ' text-dark') +' page-link c-pointer'" @click="loadData(i)" >{{i+1}}</span>
                </li>
                <li class="page-item">
                  <span v-if="numPage>curNumPage+1" class="page-link text-primary2 c-pointer" aria-label="Next" @click="loadData(curNumPage+1)">
                    <span aria-hidden="true">&raquo;</span>
                    <span class="sr-only">Next</span>
                  </span>
                  <span v-else class="page-link text-primary2" aria-label="Next">
                    <span aria-hidden="true">&raquo;</span>
                    <span class="sr-only">Next</span>
                  </span>
                </li>
              </ul>
            </nav>
          </div>
        </div>
      </div>
      <div v-if="curStep==1" class="m-2 card">
        <div class="row m-3">
          <div class="col-sm-3">
            <span class="ml-2 c-pointer text-dark" @click="goToList" title="Retour à la liste d'article">
              <i class="fa fa-arrow-left"> Retour</i>
            </span>
          </div>
          <h3 v-if="curArticle && curArticle.etat == 'unassign'" class="col-sm-6 text-center text-danger">
            Cet article n'a pas encore été assigné.
          </h3>
          <h3 v-if="curArticle && curArticle.etat == 'assign'" class="col-sm-6 text-center text-success">
            Cet article a déjà été assigné.
          </h3>

          <div class="row mt-5">
            <div class="col-sm-6">
              <h3 class="text-secondary2 ">Détails sur l'article </h3>
              <div class="col-sm-12 mt-4">
                <div v-if="curArticle && curArticle.email" class="col-sm">
                  <span class="mr-2">Email :</span>
                  <strong class=" text-dark">{{curArticle.email}}</strong>
                </div>
                <div v-if="curArticle && curArticle.docname" class="col-sm mt-3">
                  <span class="mr-2">Nom :</span>
                  <strong class=" text-dark">{{curArticle.docname}}</strong>
                </div>
                <div v-if="curArticle && curArticle.format" class="col-sm mt-3">
                  <span class="mr-2">Format :</span>
                  <strong class="text-dark text-capitalize">{{curArticle.format}}</strong>
                </div>
                <div v-if="curArticle && curArticle.doc" class="col-sm mt-3">
                  <span class="mr-2">Url :</span>
                  <strong class="text-dark">{{curArticle.doc}}</strong>
                </div>
                <div v-if="curArticle && curArticle.createdAt" class="col-sm mt-3">
                  <span class="mr-2">Ajouté le :</span>
                  <strong class="text-dark">{{getDate(curArticle.createdAt)}}</strong>
                </div>
              </div>
                  <!-- <embed class="col-sm-8" v-if="curArticle && curArticle.doc" :src="curArticle.doc" 
                    height=550 :type="'application/'+curArticle.format"/> -->
            </div>
            <div v-if="curArticle && curArticle.etat == 'unassign'" class="col-sm">
              <h4 class="text-secondary2">Choisir un Reviewer</h4>
              <form :class=" toCheckSubmit ? 'was-validated' : ''" @submit="assignToReview">

                <div class="row mb-5 mt-4 col-sm-10">
                  <div class="form-group">
                    <label class="text-dark">Reviewer <sup class="text-danger">*</sup></label>
                    <select required v-model="review.reviewer" class="form-control form-control-min">
                      <option v-for="(user, i) in reviewers" :key="i" class=""
                        :value="user._id">{{user.firstname + ' '+ user.lastname}}</option>

                    </select>
                    <div class="invalid-feedback">
                      Veuillez choisir un reviewer!
                    </div>
                  </div>

                  <div class="form-group my-4">
                    <label class="text-dark">Deadline<sup class="text-danger">*</sup></label>
                    <input class="form-control form-control-min" :min="actually" required
                      type="date" v-model="review.deadline" >
                    <div class="invalid-feedback">
                      Veuillez choisir une deadline!
                    </div>
                  </div>

                  <div class="col-sm" @click="toCheckSubmit=!toCheckSubmit">
                    <div class="form-group" >
                      <button type="submit" class=" col-sm-12 btn btn-block text-white bg-ejima">Assigner</button>
                    </div>
                  </div>

                </div>
              </form>
            </div>
          </div>
        </div>
        <div class="mt-2 mb-5 mx-auto col-sm-5">

          <!-- <div class="alert alert-danger" v-if="errorMessage.length > 0">{{errorMessage}}</div> -->

          <!-- <form :class=" (toCheckRegister ? 'was-validated' : '') + ' '"  @submit="addarticle">
            <div class="form-group">
              <label for="firstname" class="mt-2  text-primary2">First name</label>
              <input  class="form-control" v-model="newUser.firstname" required 
              placeholder="First name">
              <div class="invalid-feedback">
                Enter a First name!
              </div>
            </div>
            <div class="form-group">
              <label for="lastname" class="mt-2 text-primary2">Last name</label>
              <input  class="form-control text-uppercase" v-model="newUser.lastname" required 
              placeholder="Last name">
              <div class="invalid-feedback">
                Enter a Last name!
              </div>
            </div>
            <div class="form-group">
              <label for="password" class="mt-2 text-primary2">Email address</label>
              <input type="email" class="form-control " v-model="newUser.email" required 
              placeholder="Enter email">
              <div class="invalid-feedback">
                Enter a email address!
              </div>
            </div>
            <div class="form-group">
              <label for="password" class="mt-2 text-primary2">Role</label>
              <select name="" id="" class="form-control " v-model="newUser.role" required >
                <option selected value="reviewer">Reviewer</option>
                <option value="admin">Administrateur</option>
              </select>
              <div class="invalid-feedback">
                Enter a email address!
              </div>
            </div>
            <div class="form-group mt-2">
              <label for="password" class="mt-2 text-primary2">Password</label>
              <div class="input-group">
                <input :type="inputPwd2 ? 'password' : 'text'" minlength="8" class="form-control form-control-min"
                  title="At least 8 characters, a number, an upper case letter, a lower case letter and a special character"
                  pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[-+!#*$@%_]).{8,}" v-model="newUser.password" required 
                  placeholder="Enter password">

                <div class="input-group-prepend btn btn-outline-secondary" @click="inputPwd2=!inputPwd2">
                  <span class="" id="inputGroupPrepend">
                    <i v-if="inputPwd2==true" class="fa fa-eye"></i>
                    <i v-else class="fa fa-eye-slash"></i>
                  </span>
                </div>
                <div class="invalid-feedback">
                  Enter a Password!
                </div>
              </div>
            </div>

            <div class="form-group text-center" @click="toCheckRegister = true">
              <input type="submit" class="btn btn-primary mt-4 col-sm-12" value="Enregistrer">
            </div>

          </form> -->
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>

<script >
import moment from "moment";
moment.locale('fr');

export default {
  head() {
    return {
      // title: "acma",
    };
  },
  data() {
    return {
      ressources: [],
      curArticle: {},
      
      curStep: 0,
      toCheckRegister: false,
      inputPwd2: true,
      toCheckSubmit: false,

      searchUser: '',
      searchtext: '',
      editing: false,
      errorMessage: '',
      isLoading: false,
      password: '',

      paginate: 5,
      showPaginate: false,
      numPage: 1,
      curNumPage: 0,
      totalDatabase: 1,
      checkCreate: false,
      checkUpdate: false,
      inputPwd : true,
      inputEditPwd: true,

      curUser: {},
      review: {
        reviewer: '',
        deadline: ''
      },
      reviewers: [],
      actually: moment(moment()).utcOffset(60).format("YYYY-MM-DD"),

    };
  },
  mounted() {
    this.loadData(this.curNumPage);
    this.curStep = 0;
    this.init()
  },
  methods: {
    init(){
      if(localStorage.getItem('token') ){
        this.curUser = JSON.parse(localStorage.getItem('userInfos'));
        this.connected = true;
      } else{
        this.$alertify.warning("Vous n'êtes pas connecté. Veuillez-vous connecter !");
        this.$router.replace({ path: '/auth' });
        this.connected = false;
      }
    },
    loadData(index){
      this.isLoading = true;

      const query = {
        options: {
        },
        filter: {
          text: this.searchtext,
        },
        perPage: this.paginate,
        page: index,
        sort: {
          "createdAt": -1
        }
      };

      this.$service.list('articles', query, (data) => {
        if(data.status == 200){
          this.isLoading = false;
          this.curNumPage = index;

          this.users = data.users;
          this.totalDatabase = data.count;
          this.ressources = data.ressources;

          this.numPage = 1;
          // Traitement pagination
          if(this.totalDatabase > this.paginate){
            this.numPage = Math.trunc(this.totalDatabase / this.paginate) ;

            if(this.numPage < (this.totalDatabase / this.paginate)){
              this.numPage +=1;
            }
          }
        } else {
          console.log("Data ", data);
        }
        this.curStep=0;

      });

    },
    loadReviewers(index){
      this.isLoading = true;

      const query = {
        options: {
        },
        filter: {
          // text: this.searchtext,
          text: 'reviewer',
        },
        perPage: 60 || this.paginate,
        page: index,
        sort: {
          "createdAt": -1
        }
      };

      this.$service.list('users', query, (data) => {
        if(data.status == 200){
          console.log("Reviewer data ", data);

          this.isLoading = false;
          // this.curNumPage = index;

          this.reviewers = data.users;
          // this.totalDatabase = data.count;
          // this.reviewers = data.ressources;

          // this.numPage = 1;
          // Traitement pagination
          // if(this.totalDatabase > this.paginate){
          //   this.numPage = Math.trunc(this.totalDatabase / this.paginate) ;

          //   if(this.numPage < (this.totalDatabase / this.paginate)){
          //     this.numPage +=1;
          //   }
          // }
        } else {
          console.log("Data ", data);
        }
        // this.curStep=1;

      });

    },
    showArticle(article){
      console.log("Cur Article", article);
      this.curArticle = article;
      this.curStep =1;
    },
    assignArticle(article){
      // console.log("Cur Article", article);
      this.curArticle = article;
      if(this.reviewers && this.reviewers.length == 0){
        this.loadReviewers(0);
      }
      this.curStep =1;
    },
    goToList(){
      this.curStep =0;
    },
    assignToReview(e){
      this.isLoading=true;
      e.preventDefault();

      const assignement = {
        article: this.curArticle._id,
        admin: this.curUser._id,
        reviewer: this.review.reviewer,

        decision: 'neutre',
        deadline: this.review.deadline,
      }

      this.$service.postLogged('reviewes/create', assignement, (data) => {
        this.isLoading=false;
        console.log("Review response : ", data);

        if(data.status == 200){
          this.errorMessage = '';
          this.review = {
            deadline: '',
            reviewer: '',
          }
          this.loadData(this.curNumPage)

            this.$alertify.alert('Nouvel article assigné avec succès!', 
              `Vous venez d'assigner un nouvel article à un reviewer. Merci`
            );
          // }
        } else {
          return this.errorMessage = data.message;
        }

      });
    
    },
    doPaginate(){
      this.curNumPage=0;
      this.numPage = Math.trunc(this.totalDatabase / this.paginate) ;

      if(this.numPage < this.totalDatabase / this.paginate){
        this.numPage +=1;
      }
      this.loadData(this.curNumPage);
    },
    getDate(data){
      return moment(data).utcOffset(60).format("LLLL");
    },
  },
};
</script>

<style lang="scss" scoped>

</style>
